.\"	$NetBSD: resolv.conf.5,v 1.23 2003/09/07 16:22:29 wiz Exp $
.\"
.\" Copyright (c) 1986, 1991 The Regents of the University of California.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)resolver.5	5.12 (Berkeley) 5/10/91
.\"
.Dd January 16, 1999
.Dt RESOLV.CONF 5
.Os
.Sh NAME
.Nm resolv.conf
.Nd resolver configuration file
.Sh DESCRIPTION
The
.Nm resolv.conf
file specifies how the
.Xr resolver 3
routines in the C library
(which provide access to the Internet Domain Name System) should operate.
The resolver configuration file contains information that is read
by the resolver routines the first time they are invoked by a process.
The file is designed to be human readable and contains a list of
keywords with values that provide various types of resolver information.
.Pp
On a normally configured system this file should not be necessary.
The only name server to be queried will be on the local machine,
the domain name is determined from the host name,
and the domain search path is constructed from the domain name.
.Pp
The different configuration options are:
.Bl -tag -width nameserver
.It Sy nameserver
IPv4 address
.Pq in dot notation
or IPv6 address
.Pq in hex-and-colon notation
of a name server that the resolver should query.
Scoped IPv6 address notation is accepted as well
.Po
see
.Xr inet6 4
for details
.Pc .
Up to
.Dv MAXNS
(currently 3) name servers may be listed,
one per keyword.
If there are multiple servers,
the resolver library queries them in the order listed.
If no
.Sy nameserver
entries are present,
the default is to use the name server on the local machine.
(The algorithm used is to try a name server, and if the query times out,
try the next, until out of name servers,
then repeat trying all the name servers
until a maximum number of retries are made).
.It Sy domain
Local domain name.
Most queries for names within this domain can use short names
relative to the local domain.
If no
.Sy domain
entry is present, the domain is determined
from the local host name returned by
.Xr gethostname 3 ;
the domain part is taken to be everything after the first `.'.
Finally, if the host name does not contain a domain part, the root
domain is assumed.
.It Sy lookup
This keyword is now ignored: its function has been superseded by
features of
.Xr nsswitch.conf 5 .
.Pp
.It Sy search
Search list for host-name lookup.
The search list is normally determined from the local domain name;
by default, it begins with the local domain name, then successive
parent domains that have at least two components in their names.
This may be changed by listing the desired domain search path
following the
.Sy search
keyword with spaces or tabs separating
the names.
Most resolver queries will be attempted using each component
of the search path in turn until a match is found.
Note that this process may be slow and will generate a lot of network
traffic if the servers for the listed domains are not local,
and that queries will time out if no server is available
for one of the domains.
.Pp
The search list is currently limited to six domains
with a total of 1024 characters.
.It Sy sortlist
Sortlist allows addresses returned by gethostbyname to
be sorted.
A sortlist is specified by IP address netmask pairs.
The netmask is optional and defaults to the natural
netmask of the net.
The IP address and optional network pairs are separated by
slashes.
Up to 10 pairs may be specified, ie.
.Pp
.Sy sortlist 130.155.160.0/255.255.240.0 130.155.0.0
.It Sy options
Options allows certain internal resolver variables to be modified.
The syntax is:
.Pp
.Sy options option ...
.Pp
where option is one of the following:
.Bl -tag -width insecure1
.It Sy debug
enable debugging information, by setting RES_DEBUG in _res.options
(see
.Xr resolver 3 ) .
.It Sy edns0
attach OPT pseudo-RR for ENDS0 extension specified in RFC 2671,
to inform DNS server of our receive buffer size.
The option will allow DNS servers to take advantage of non-default receive
buffer size, and to send larger replies.
DNS query packets with EDNS0 extension is not compatible with
non-EDNS0 DNS servers.
The option must be used only when all the DNS servers listed in
.Sy nameserver
lines are able to handle EDNS0 extension.
.It Sy inet6
enable support for IPv6-only applications, by setting RES_USE_INET6 in
_res.options (see
.Xr resolver 3 ) .
The option is meaningful with certain kernel configuration only and
use of this option is discouraged.
.It Sy insecure1
Do not require IP source address on the reply packet to be equal to the
servers' address.
.It Sy insecure2
Do not check if the query section of the reply packet is equal
to that of the query packet.
For testing purposes only.
.It Sy ndots:n
sets a threshold for the number of dots which
must appear in a name given to res_query (see
.Xr resolver 3 )
before an initial absolute query will be made.
The default for n is 1, meaning that if there are any
dots in a name, the name will be tried first as an absolute
name before any search list elements are appended to it.
.El
.El
.Pp
The
.Sy domain
and
.Sy search
keywords are mutually exclusive.
If more than one instance of these keywords is present,
the last instance will override.
.Pp
The
.Sy search
keyword of a system's
.Pa resolv.conf
file can be overridden on a per-process basis by setting the
environment variable
.Ev LOCALDOMAIN
to a space-separated list of search domains.
.Pp
The
.Sy options
keyword of a system's
.Pa resolv.conf
file can be amended on a per-process basis by setting the
environment variable
.Ev RES_OPTIONS
to a space-separated list of resolver options as explained above.
.Pp
The keyword and value must appear on a single line, and the keyword
(e.g.
.Sy nameserver )
must start the line.  The value follows
the keyword, separated by white space.
.Sh FILES
.Bl -tag -width /etc/resolv.conf -compact
.It Pa /etc/resolv.conf
The file
.Nm resolv.conf
resides in
.Pa /etc .
.El
.Sh SEE ALSO
.Xr gethostbyname 3 ,
.Xr resolver 3 ,
.Xr nsswitch.conf 5 ,
.Xr hostname 7 ,
.Xr named 8
.Rs
.%T "Name Server Operations Guide for BIND"
.Re
.Sh HISTORY
The
.Nm resolv.conf
file format appeared in
.Bx 4.3 .
